/* NessusJ
 * Copyright (C) 1998 Alexis de Bernis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This deals with plugin families. It's also a component.
 *
 *  Please run class NessusJ instead.
 */

import java.lang.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;


class Family extends JPanel implements ActionListener
{
    private Hashtable children;
    private String name;
    private JCheckBox state;
    private JButton nameToClick;

    Family(String name)
    {
        super(new BorderLayout());

        this.name=name;

        children=new Hashtable();
        state=new JCheckBox("",true);
        state.addActionListener(this);
        state.setActionCommand("state");
        state.setIcon(new ImageIcon("l_red.gif"));
        state.setSelectedIcon(new ImageIcon("l_green.gif"));
        nameToClick=new JButton(name);
        nameToClick.setBorder(new EmptyBorder(0,0,0,0));
        nameToClick.addActionListener(this);
        setBorder(new EtchedBorder());

        add("West",nameToClick);
        add("East",state);
    }

    public Hashtable getChildren()
    {
        return(children);
    }

    public void addChild(PlugIn child)
    {
        children.put(child.getName(),child);
    }

    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("state"))
        {
            Enumeration temp=children.elements();

            while(temp.hasMoreElements())
                ((PlugIn) temp.nextElement()).setActivated(state.isSelected());
        }

        if(command.equals(name))
        {
            ((PluginList) getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent()).refreshList(this);

        }

    }




}
